# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class SystemSettingsRequest(Model):
    """SystemSettingsRequest.

    :param organization_name: The organization name
    :type organization_name: str
    :param display_organization_name_in_header: Indicates whether or not
     organization name should be displayed in the application header <span
     class='property-internal'>Required</span>
    :type display_organization_name_in_header: bool
    :param organization_logo: The organization logo
     May be a base64-encoded PNG, JPG, or SVG image or a URI for an image
     hosted online
     A null value will clear the saved image
    :type organization_logo: str
    :param automatic_logout_minutes: Number of minutes after which users will
     be automatically logged out <span class='property-internal'>Must be
     between 10 and 780</span>
    :type automatic_logout_minutes: int
    :param default_country: Default country for new users <span
     class='property-internal'>One of US, CA, OTHER </span>
    :type default_country: str
    :param default_meter_time_zone_id: ID of the default time zone for new
     meters <span class='property-internal'>Required</span>
    :type default_meter_time_zone_id: int
    :param default_date_format: Default date format for new users <span
     class='property-internal'>One of MM/dd/yyyy, dd/MM/yyyy </span>
    :type default_date_format: str
    """

    _validation = {
        'organization_name': {'required': True},
        'display_organization_name_in_header': {'required': True},
        'organization_logo': {'required': True, 'min_length': 5},
        'automatic_logout_minutes': {'required': True, 'maximum': 780, 'minimum': 10},
        'default_meter_time_zone_id': {'required': True},
    }

    _attribute_map = {
        'organization_name': {'key': 'organizationName', 'type': 'str'},
        'display_organization_name_in_header': {'key': 'displayOrganizationNameInHeader', 'type': 'bool'},
        'organization_logo': {'key': 'organizationLogo', 'type': 'str'},
        'automatic_logout_minutes': {'key': 'automaticLogoutMinutes', 'type': 'int'},
        'default_country': {'key': 'defaultCountry', 'type': 'str'},
        'default_meter_time_zone_id': {'key': 'defaultMeterTimeZoneId', 'type': 'int'},
        'default_date_format': {'key': 'defaultDateFormat', 'type': 'str'},
    }

    def __init__(self, organization_name, display_organization_name_in_header, organization_logo, automatic_logout_minutes, default_meter_time_zone_id, default_country=None, default_date_format=None):
        super(SystemSettingsRequest, self).__init__()
        self.organization_name = organization_name
        self.display_organization_name_in_header = display_organization_name_in_header
        self.organization_logo = organization_logo
        self.automatic_logout_minutes = automatic_logout_minutes
        self.default_country = default_country
        self.default_meter_time_zone_id = default_meter_time_zone_id
        self.default_date_format = default_date_format
